Attribute VB_Name = "basCommandBars"
Option Explicit
'*************************************************************************
'Items Command Bar
'Module: basCommandBars
'Sample Outlook 2000 COM Add-in application
'Provided by Micro Eye, Inc.
'http://www.microeye.com
'You can modify this COM Add-in project to suit your own requirements
'No support is provided for this sample COM Add-in project
'Purpose: Demonstrate a simple COM Add-in built using Outlook 2000
'*************************************************************************
'Public array for forms
'This array holds folder-level custom form display name and message class
Public avarForms

Public Function CreateAddInCommandBarButton _
    (strProgID As String, objCommandBar As CommandBar, _
    strCaption As String, strTag As String, strTip As String, _
    intFaceID As Integer, blnBeginGroup As Boolean, intStyle As Integer) _
    As Office.CommandBarButton
    
    Dim ctlBtnAddin As CommandBarButton
    On Error Resume Next
    ' Test to determine if button exists on command bar.
    Set ctlBtnAddin = objCommandBar.FindControl(Tag:=strTag)
    If ctlBtnAddin Is Nothing Then
        ' Add new button.
        Set ctlBtnAddin = objCommandBar.Controls.Add(Type:=msoControlButton, _
            Parameter:=strTag)
        ' Set button's Caption, Tag, Style, and OnAction properties.
        With ctlBtnAddin
            .Caption = strCaption
            .Tag = strTag
            If intStyle <> msoButtonCaption Then
                .FaceId = intFaceID
            End If
            .Style = intStyle
            .ToolTipText = strTip
            .BeginGroup = blnBeginGroup
            ' Set the OnAction property with ProgID of Add-In
            .OnAction = "<!" & strProgID _
                & ">"
        End With
    End If
    
    ' Return reference to new commandbar button.
    Set CreateAddInCommandBarButton = ctlBtnAddin

End Function

Public Function CreateAddInCommandBarComboBox _
    (strProgID As String, objCommandBar As CommandBar, _
    strCaption As String, strTag As String, strTip As String, _
    blnBeginGroup As Boolean) _
    As Office.CommandBarComboBox
    
    Dim ctlBtnAddin As CommandBarComboBox

    On Error Resume Next
    ' Test to determine if combobox exists on command bar.
    Set ctlBtnAddin = objCommandBar.FindControl(Tag:=strTag)
    If ctlBtnAddin Is Nothing Then
        ' Add new button.
        Set ctlBtnAddin = objCommandBar.Controls.Add(Type:=msoControlComboBox, _
            Parameter:=strTag)
        ' Set button's Caption, Tag, Style, and OnAction properties.
        With ctlBtnAddin
            .Caption = strCaption
            .Tag = strTag
            .ToolTipText = strTip
            .BeginGroup = blnBeginGroup
            ' Set the OnAction property with ProgID of Add-In
            .OnAction = "<!" & strProgID _
                & ">"
        End With
    End If
    
    ' Return reference to new commandbar button.
    Set CreateAddInCommandBarComboBox = ctlBtnAddin

End Function

'*************************************************************
'Procedure: cmdCreateForm
'Purpose: Create a new item from message class in current fld
'Argument: n/a
'Usage: 'Items CommandBar ComboBox Change event calls this sub
'Returns: n/a
'*************************************************************
Public Sub cmdCreateForm()
    Dim objCB As Office.CommandBar
    Dim objCBB As Office.CommandBarComboBox
    Dim objFolder As Outlook.MAPIFolder
    Dim objItem As Object
    On Error Resume Next
    Set objCB = golApp.ActiveExplorer.CommandBars("Items")
    Set objCBB = objCB.FindControl(Type:=msoControlDropdown)
    Set objFolder = golApp.ActiveExplorer.CurrentFolder
    'Column 1 of array contains message class for custom form
    'objFolder.Items.Add("IPM.Note.My Custom Note")
    'avarForms is a public variable
    Set objItem = objFolder.Items.Add _
        (avarForms(objCBB.ListIndex - 1, 1))
    objItem.Display
End Sub

