Attribute VB_Name = "basRegistry"
Option Explicit
'*************************************************************************
'Items Command Bar
'Module: basRegistry
'Sample Outlook 2000 COM Add-in application
'Provided by Micro Eye, Inc.
'http://www.microeye.com
'You can modify this COM Add-in project to suit your own requirements
'No support is provided for this sample COM Add-in project
'Purpose: Demonstrate a simple COM Add-in built using Outlook 2000
'*************************************************************************
Public Const REG_SZ As Long = 1
Public Const REG_DWORD As Long = 4

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
'Error codes
Public Const ERROR_NONE = 0
Public Const ERROR_BADDB = 1
Public Const ERROR_BADKEY = 2
Public Const ERROR_CANTOPEN = 3
Public Const ERROR_CANTREAD = 4
Public Const ERROR_CANTWRITE = 5
Public Const ERROR_OUTOFMEMORY = 6
Public Const ERROR_INVALID_PARAMETER = 7
Public Const ERROR_ACCESS_DENIED = 8
Public Const ERROR_INVALID_PARAMETERS = 87
Public Const ERROR_NO_MORE_ITEMS = 259
 
Public Const KEY_ALL_ACCESS = &H3F
 
Public Const REG_OPTION_NON_VOLATILE = 0
 
Declare Function RegCloseKey Lib "advapi32.dll" _
(ByVal hKey As Long) As Long
Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias _
"RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, _
ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions _
As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes _
As Long, phkResult As Long, lpdwDisposition As Long) As Long
Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias _
"RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, _
ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As _
Long) As Long
Declare Function RegQueryValueExString Lib "advapi32.dll" Alias _
"RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
String, ByVal lpReserved As Long, lpType As Long, ByVal lpData _
As String, lpcbData As Long) As Long
Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias _
"RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
String, ByVal lpReserved As Long, lpType As Long, lpData As _
Long, lpcbData As Long) As Long
Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias _
"RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As _
String, ByVal lpReserved As Long, lpType As Long, ByVal lpData _
As Long, lpcbData As Long) As Long
Declare Function RegSetValueExString Lib "advapi32.dll" Alias _
"RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As _
String, ByVal cbData As Long) As Long
Declare Function RegSetValueExLong Lib "advapi32.dll" Alias _
"RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, _
ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, _
ByVal cbData As Long) As Long
Declare Function OSRegOpenKey Lib "advapi32" Alias "RegOpenKeyA" _
    (ByVal hKey As Long, ByVal lpszSubKey As String, phkResult As Long) As Long
Declare Function OSRegCreateKey Lib "advapi32" Alias "RegCreateKeyA" _
    (ByVal hKey As Long, ByVal lpszSubKey As String, phkResult As Long) As Long

'SetValueEx and QueryValueEx Wrapper Functions

Public Function SetValueEx(ByVal hKey As Long, sValueName As String, _
lType As Long, vValue As Variant) As Long
    Dim lValue As Long
    Dim sValue As String
    Select Case lType
        Case REG_SZ
            sValue = vValue
            SetValueEx = RegSetValueExString(hKey, sValueName, 0&, lType, sValue, Len(sValue))
        Case REG_DWORD
            lValue = vValue
            SetValueEx = RegSetValueExLong(hKey, sValueName, 0&, lType, lValue, 4)
        End Select
End Function

Function QueryValueEx(ByVal lhKey As Long, ByVal szValueName As _
String, vValue As Variant) As Long
    Dim cch As Long
    Dim lRC As Long
    Dim lType As Long
    Dim lValue As Long
    Dim sValue As String
 
    On Error GoTo QueryValueExError
 
    ' Determine the size and type of data to be read
    lRC = RegQueryValueExNULL(lhKey, szValueName, 0&, lType, 0&, cch)
    If lRC <> ERROR_NONE Then Error 5
 
    Select Case lType
        ' For strings
        Case REG_SZ:
            sValue = String(cch, 0)
lRC = RegQueryValueExString(lhKey, szValueName, 0&, lType, sValue, cch)
            If lRC = ERROR_NONE Then
                vValue = Left$(sValue, cch)
            Else
                vValue = Empty
            End If
        ' For DWORDS
        Case REG_DWORD:
lRC = RegQueryValueExLong(lhKey, szValueName, 0&, lType, lValue, cch)
            If lRC = ERROR_NONE Then vValue = lValue
        Case Else
            'all other data types not supported
            lRC = -1
    End Select
 
QueryValueExExit:
    QueryValueEx = lRC
    Exit Function
QueryValueExError:
    Resume QueryValueExExit
End Function

'***************************************************************************************************************************
'Function       GetKeyValueEx
'Purpose:       Get Registry Values-Note: Supports only REG_SZ and REG_DWORD
'Returns:       Registry Value by Key
'Usage:         strValue=GetKeyValueEx(HKEY_LOCAL_MACHINE,"Software\Microsoft\Schedule+\Application","AppPath")
'***************************************************************************************************************************

Public Function GetKeyValueEx(lKey As Long, sKeyName As String, sValueName As String) As Variant
On Error GoTo GetKeyValue_Error:
       Dim lRetVal As Long        'result of the API functions
       Dim hKey As Long           'handle of opened key
       Dim vValue As Variant      'setting of queried value
 
       lRetVal = OSRegOpenKey(lKey, sKeyName, hKey)
       lRetVal = QueryValueEx(hKey, sValueName, vValue)
       If Len(vValue) Then 'Trim null
            If Right$(vValue, 1) = Chr$(0) Then
                vValue = Left$(vValue, Len(vValue) - 1)
            End If
       End If
       GetKeyValueEx = vValue
       RegCloseKey (hKey)
       
GetKeyValue_Exit:
Exit Function

GetKeyValue_Error:
GetKeyValueEx = ""
Resume GetKeyValue_Exit
End Function
 
'***************************************************************************************************************************
'Function:      SetKeyValue
'Purpose:       Set Registry Values
'Returns:       TRUE is successful; FALSE if error
'Usage:         SetKeyValue(HKEY_CURRENT_USER,"Software\Microsoft\Office\9.0\Outlook\Preferences","Annotation Text","User Name",REG_SZ)
'***************************************************************************************************************************
Public Function SetKeyValue(lKey As Long, sKeyName As String, sValueName As String, vValueSetting As Variant, lValueType As Long) As Boolean
On Error GoTo SetKeyValue_Error
    Dim lRetVal As Long      'result of the SetValueEx function
    Dim hKey As Long         'handle of open key
    
    If Left$(sKeyName, 1) = "\" Then
        sKeyName = Mid$(sKeyName, 2)
    ElseIf sKeyName = "" Then   'can't have blank key name
        SetKeyValue = False
        Exit Function
    End If
    
    lRetVal = OSRegCreateKey(lKey, sKeyName, hKey)
    lRetVal = SetValueEx(hKey, sValueName, lValueType, vValueSetting)
    RegCloseKey (hKey)
    SetKeyValue = True
       
SetKeyValue_Exit:
Exit Function

SetKeyValue_Error:
Resume SetKeyValue_Exit

End Function
 
Function StripTerminator(ByVal strString As String) As String
    Dim intZeroPos As Integer

    intZeroPos = InStr(strString, Chr$(0))
    If intZeroPos > 0 Then
        StripTerminator = Left$(strString, intZeroPos - 1)
    Else
        StripTerminator = strString
    End If
End Function
